/*
     Tacitus @ LPUniversity
     26-FEB-06
     Admin Object
*/

// Last updated on April 15th, 2006 by Tacitus@LPUniversity

inherit OBJECT;

/* Function Prototypes */

int mm_select(string arg);
int create_group(string arg);
int delete_group(string arg);
int delete_message(string group);
int purge_group(string args);
int add_client(string args);
int del_client(string args);

int delete_message_final(string id, string group);

/* Functions */

int main_menu()
{
	if(!adminp(this_player())) return 0;

     write("\n\t-= NEWS SYSTEM ADMINISTRATION =-\n\n");
     write(
     "1. Create a new news group.\n"
     "2. Delete a news group.\n"
     "3. Delete a post in a news group.\n"
     "4. Purge a news group.\n"
     "5. Authorize a news client.\n"
     "6. Unauthorize an authorized news client.\n"
     "7. News system permissions.\n"
     "8. Quit\n\n");

     write("Main Menu > ");
     input_to("mm_select");
     return 1;
}

int mm_select(string arg)
{
     int select;

     select = to_int(arg);
     if(!intp(select)) return main_menu();

     switch(select)
     {
          case 1 :
          {
               write("\nName of new group: ");
               input_to("create_group");
               return 1;
          }

          case 2 :
          {
               write("\nName of group to delete: ");
               input_to("delete_group");
               return 1;
          }

          case 3 :
          {
               write("\nName of group where message exists: ");
               input_to("delete_message");
               return 1;
          }

          case 4 :
          {
               write("\nName of group to purge: ");
               input_to("purge_group");
               return 1;
          }

          case 5 :
          {
               write("\nFull path to client: ");
               input_to("add_client");
               return 1;
          }

          case 6 :
          {
               write("\nFull path to client: ");
               input_to("del_client");
               return 1;
          }

          case 7 :
          {
               write("\nFeature not implemented.\n");
               return main_menu();
          }

          case 8 :
          {
          	write("\nExiting news daemon admin interface...\n");
          	destruct(this_object());
          	return 1;
          }

          default : return main_menu();
     }

}

int create_group(string arg)
{
     if(!stringp(arg)) return main_menu();
     write(NEWS_D->adminAction_createGroup(arg) ? "\n%^BOLD%^Success.%^RESET%^\n" : "\n%^BOLD%^RED%^Failure.%^RESET%^\n");
     return main_menu();
}

int delete_group(string arg)
{
     if(!stringp(arg)) return main_menu();
     write(NEWS_D->adminAction_deleteGroup(arg) ? "\n%^BOLD%^Success.%^RESET%^\n" : "\n%^BOLD%^RED%^Failure.%^RESET%^\n");
     return main_menu();
}

int delete_message(string group)
{
	write("\nEnter id of message: ");
	input_to("delete_message_final", 0, group);
	return 1;
}

int delete_message_final(string id, string group)
{
	int numerical_id = to_int(id);
	if(!intp(numerical_id))
	{
		write("\n%^BOLD%^RED%^Invalid Input%^RESET%^\n");
		return main_menu();
	}

	write(NEWS_D->adminAction_deletePost(group, numerical_id) ? "\n%^BOLD%^Success.%^RESET%^\n" : "\n%^BOLD%^RED%^Failure.%^RESET%^\n");

	return main_menu();
}

int purge_group(string args)
{
	write( NEWS_D->adminAction_deleteGroup(args) && NEWS_D->adminAction_createGroup(args) ? "\n%^BOLD%^Success.%^RESET%^\n" : "\n%^BOLD%^RED%^Failure.%^RESET%^\n");

	return main_menu();
}

int add_client(string args)
{
	write( NEWS_D->authorizeClient(args) ? "\n%^BOLD%^Success.%^RESET%^\n" : "\n%^BOLD%^RED%^Failure.%^RESET%^\n");

	return main_menu();
}

int del_client(string args)
{
	write( NEWS_D->revokeClientAuthorization(args) ? "\n%^BOLD%^Success.%^RESET%^\n" : "\n%^BOLD%^RED%^Failure.%^RESET%^\n");

	return main_menu();
}
