//ls.c

//Tacitus @ LPUniversity
//04-APR-05
//File Navigation

/*
  Changes:

    Vicore, 11/20/05 - Fixed a bug misidentifying directories
*/

//Last edited on November 20, 2005 by Vicore

int main(string arg)
{
    string path;
    string *dir;
    int first_period, i;
    int bonusPadding, maxFileNameSize;

    if(!arg)
    {
	arg = this_player()->query("cwd");
	if (!arg) arg = "/";
    }

    if (arg[<1..<1] == " ")
	arg = arg[0..<2];

    if (arg == "/..") {
	write("Error [ls]: no such directory.\n");
	return 1;
    }

    if(arg == ".") arg = this_player()->query("cwd");

    if (arg[<1..<1] != "/")
	arg = arg + "/";
    path = arg;

    if (arg[<1..<1] == "/") {
	arg =  arg + "*";
    }

    else {
	for (i = strlen(path); path[--i] != 47;);
	first_period = path[i+1] == '.';
	path = path[0..i];
    }

    if(arg[0..0] != "/")
	arg = this_player()->query("cwd") +
	(this_player()->query("cwd") == "/" ? "" : "/") + arg;
    if(!get_dir(arg))
    {
	write("Error [ls]: Invalid directory. Change directory to a valid directory.\n");
	return 1;
    }

    dir = get_dir(arg);

    if (!sizeof(dir)) {
	write("Error [ls]: no such file or directory.\n");
	return 1;
    }

    write("%^BOLD%^Directory: %^RESET%^" + arg + "\n");

    foreach(string name in dir)
    if(strlen(name) > maxFileNameSize) maxFileNameSize = strlen(name);

    if(maxFileNameSize > 11) bonusPadding = 15;
    else if(maxFileNameSize > 9) bonusPadding = 5;
    else bonusPadding = 0;

    for(i = 0; i < sizeof(dir); i++)
    {
	if((i%4)==0) printf("\n");
	if(directory_exists(replace_string(arg, "*", "") + dir[i])|| dir[i] == "..") printf("%-" + (20 + bonusPadding) + "s", dir[i] + "/");
	else printf("%-" + (20 + bonusPadding) + "s", dir[i]);
    }

    write("\n");
    return 1;
}

string help() {
    return (HIW + " SYNTAX: " + NOR + "ls [arguements]\n\n" +
      "This command takes on an optional arguement.\n" +
      "With no arguement, this command displays the contents of the\n" +
      "directory you are currently in. With one arguement, this\n" +
      "command displays the contents of a specified\n" +
      "directory.\n");
}
